import { NextFunction, Request as ERequest, Response } from 'express';
import { AuthResponse } from "./models/authResponse";
import { Request } from './models/request';
import { Endpoint } from './models/endpoint';
/**
 * Bootstraps the whole application.
 * @param params Params to assist with the bootstrapping process.
 */
export declare function bootstrap(params: {
    /**
     * The base route for all endpoints - for example: /api/v1
     */
    base?: string;
    /**
     * Method to call while performing authentication and authorization on different routes.
     */
    authCallback?: (req: Request, endpoint: Endpoint) => AuthResponse;
}): (req: ERequest, res: Response, next: NextFunction) => Response<any> | undefined;
