"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Controller = void 0;
const container_1 = require("../container");
const awilix_1 = require("awilix");
const constants_1 = require("../constants/constants");
const consoleConstants_1 = require("../constants/consoleConstants");
function Controller(constructor) {
    const controllerName = constructor.name.replace('Controller', '');
    container_1.ControllersContainer.set(controllerName.toLowerCase(), constructor, awilix_1.Lifetime.SINGLETON);
    // Performing validations on the input controller that it extends the BaseController.
    const controller = container_1.ControllersContainer.get(controllerName.toLowerCase());
    if (controller && !controller.hasOwnProperty(constants_1.baseControllerClassIdentifier)) {
        const message = `${consoleConstants_1.FgRed}[error] Controller '${controllerName}' doesn't extend BaseController. It won't be registered unless you extend it from BaseController.${consoleConstants_1.Reset}`;
        console.warn(message);
        container_1.ControllersContainer.remove(controllerName.toLowerCase());
    }
}
exports.Controller = Controller;
