"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deserialize = void 0;
function deserialize(param, type) {
    return deserializer(param, type);
}
exports.deserialize = deserialize;
function deserializer(param, type, parentType, paramName) {
    const response = new type();
    let parent;
    if (parentType) {
        parent = new parentType();
    }
    for (let key in param) {
        if (typeof param[key] === 'object') {
            if (response.constructor.name === 'Array') {
                const arrayType = parent.compositions.find(x => x.property === paramName);
                if (arrayType) {
                    response.push(deserializer(param[key], arrayType.type, type, key));
                }
            }
            else {
                let arrayType;
                if (response.compositions) {
                    arrayType = response.compositions.find(x => x.property === key);
                }
                const constructor = arrayType ? (arrayType.isCollection ? Array : arrayType.type) : response[key].constructor;
                response[key] = deserializer(param[key], constructor, type, key);
            }
        }
        else {
            response[key] = param[key];
        }
    }
    return response;
}
